import bluetooth
import time

nearby_devices = None

def sendData(target_address, geraetename):
   try:
      msg = input("Eingabe: ")
      print(msg)
      if len(msg) > 0:
         print(f"Aufbau der Verbindung zu {geraetename} {target_address} wird aufgebaut.")
         for s in msg:
            port = 1
            sock=bluetooth.BluetoothSocket( bluetooth.RFCOMM )
            sock.connect((target_address, port))
            sock.send(s)
            print(s)
            sock.close()
            time.sleep(2)
         searchDevices()
   except Exception as err:
      print(f"Fehler beim senden der Daten an {geraetename}!")
      print(f"{err=}, {type(err)=}")


def searchDevices():
   global nearby_devices
   if nearby_devices == None:
      print("Suche Bluetoothgeräte")
      nearby_devices = bluetooth.discover_devices(lookup_names=True)
      print(f"Es wurde(n) {len(nearby_devices)} Gerät(e) gefunden!")

   if len(nearby_devices) > 0:
      print("Gefundene Geräte:")
      index = 0
      for addr, name in nearby_devices:
         print(f"\t[{index}] Gerätename: {name}, Adresse: {addr}")
         index = index + 1
      print("\t[S] Suche neustarten")
      print("\t[E] Ende")

      eingabe = input("Wähle ein Gerät zum senden von Daten: ")
      if eingabe.upper()  == "E":
         print("Ende")
      elif eingabe.upper() == "S":
         nearby_devices = None
         searchDevices()
      elif eingabe.isnumeric():
         adresse = nearby_devices[int(eingabe)][0]
         geraetename = nearby_devices[int(eingabe)][1]
         sendData(adresse, geraetename)

searchDevices()
